@echo off
color F0
cls
echo  -------------------------------------------------------------------
echo  Statische ARP Eintraege fuer Gateway (IPCOP) und Server  (H.Pajnik)
echo  -------------------------------------------------------------------
echo  Dieses Programm generiert die Batch "setarp.bat" 
::    \\schule.aps\netlogon\AScripts\SetArp.bat" im netlogon-Verzeichnis, 
::    welche von den Clients via STARTPC.BAT aufgerufen wird.
::    (Schreibzugriff noetig)
echo.
echo  Dadurch erhalten die Clients beim Start eine statische
echo  Zuordnung von IP-Adresse und MAC-Adresse fuer Server und Gateway 
::    Muster:  arp -s 192.168.4.5 xx-xx-xx-xx-xx-xx
echo. 
::    Dies ist eine Gegenmaszmahme gegen arp-Spoofing, bzw.
::    einen man-in-the-middle Angriff.
::
::    Zustzlicher Eintrag in STARTPC.BAT und STARTPC1.BAT erforderlich: 
::    =:  call \\schule.aps\netlogon\AScripts\SetArp.bat
echo  ------------------------------------------------------------------


:: #######################################################
:: Voreinstellungen:
:: -----------------
::
:: ---Von STARTPC.BAT aufgerufene Batch-----
set CALLBAT=\\schule.aps\netlogon\AScripts\SetArp.bat
::
:: ---Server-IP------------
set IPADDR1=192.168.100.200
set DESCR1=Server
::
:: ---Gateway-IP-----------
set IPADDR2=192.168.100.254
set DESCR2=Gateway
::
:: ---Reserve-IP-----------
:: set IPADDR3=192.168.100.254
:: set DESCR3=Dummy
::
:: ---Reserve-IP-----------
:: set IPADDR4=192.168.100.254
:: set DESCR4=Dummy
::
:: ---Ende Voreinstellungen-------------------------------
:: #######################################################
::


set TMPBATCH=%TEMP%\arptmp.txt
set RESFILE=%TEMP%\res1tmp.txt
set RESCOUNT=%TEMP%\res2tmp.txt
set IPCOUNT=0
set MYERROR=0
set MYSERVER=0

:: ------Programmstart-----
::
if exist %TMPBATCH% del %TMPBATCH%
echo ^:^: -----------------------------------------------------------   > %TMPBATCH%
echo ^:^: - Statische ARP Eintraege fuer Gateway und Server         -  >> %TMPBATCH%
echo ^:^: -----------------------------------------------------------  >> %TMPBATCH%
echo ^:^: -     Diese Datei wurde automatisch generiert             -  >> %TMPBATCH%
echo ^:^: -     Diese Datei wird von STARTPC.BAT aufgerufen         -  >> %TMPBATCH%
echo ^:^: -----------------------------------------------------------  >> %TMPBATCH%
echo ^:^:                                                              >> %TMPBATCH%
::
:: ---Server------------------------
CALL :procline %IPADDR1%
::
:: ---Gateway-----------------------
CALL :procline %IPADDR2%
::
:: ---Eintrag3-----------------------
:: CALL :procline %IPADDR3%
::
:: ---Eintrag4-----------------------
:: CALL :procline %IPADDR4%
::





if "%MYERROR%"=="1" goto :SHOWERROR
    set IPCOUNT=0
    if exist "%CALLBAT%" (
echo.
        rem echo Datei "%CALLBAT%" ist schon vorhanden
        echo.
        echo ====== Zeige vorhandene Datei:"%CALLBAT%"===========
        type "%CALLBAT%"
        echo =======================Ende der Datei==================================
        echo.
        echo.
        fc /L "%CALLBAT%" "%TMPBATCH%" |find /c "Keine Unterschiede" > %RESCOUNT%
        FOR /F  %%i IN (%RESCOUNT%) DO set IPCOUNT=%%i
    )
    if ."%IPCOUNT%"==."1" (
        echo Die Eintraege sind mit den neuen Werten identisch!
        echo Datei muss nicht kopiert werden!
	echo.
    ) ELSE (
        echo.
        echo ======Zeige neue Datei=================================================
        type %TMPBATCH%
        echo ======================Ende der Datei===================================
        echo.
        if exist "%CALLBAT%" (
           echo.
           echo --------------------------------------------------------------------
           echo WARNUNG: Die Dateien untescheiden sich!
           echo          Gibt es einen Grund fuer die Unterschiede ?
	   echo          z.B: Erstinstallation, neue Netzwerkkarte, anderes Gateway
	   echo --------------------------------------------------------------------
           echo.
        )
        echo.
        echo ------------------------------------------------------------------
        echo         Bei Tastendruck wird die Datei nun kopiert nach:         
        echo         %CALLBAT%
	echo ------------------------------------------------------------------
        echo -        ^<TASTE^>      oder      ^<Abbrechen mit STRG-C^>           -
	echo ------------------------------------------------------------------
        pause > nul
        copy %TMPBATCH% %CALLBAT%
    )
goto :ENDE

:SHOWERROR
    echo.
    echo -----------------------------------------------
    echo -   Automatische Eintragung nicht moeglich    -
    echo -----------------------------------------------
    echo -   Datei wird nicht gespeichert !            -
    echo -----------------------------------------------
    echo -       Programm beendet sich nun             -
    echo -----------------------------------------------
    echo.


:ENDE
pause
goto :eof



:: -------------------------------------------------------------------
:procline 
REM %1=IP-Adresse
set IPADDR=%1
set MYSERVER=0
if exist %RESFILE% del %RESFILE%
if exist %RESCOUNT% del %RESCOUNT%
ping -n 1 %IPADDR% > NUL 2>NUL
arp -a | find /c "%IPADDR%" > %RESCOUNT%
:: echo --rescount--
:: type %rescount%
:: echo ---
FOR /F  %%i IN (%RESCOUNT%) DO set IPCOUNT=%%i
:: echo gefundene MACs: %IPCOUNT%
if ."%IPCOUNT%"==."0" (
    color CF
    echo ---------------------------------------------------------------
    echo "IP: %IPADDR% NICHT ERREICHBAR oder NICHT GEFUNDEN"
    echo ---------------------------------------------------------------
    set MYERROR=1
) ELSE (
    arp -a | find "%IPADDR%" > %RESFILE%
    REM  Wichtig: Leerzeichen -als Trenner- nach delims.
    FOR /F "tokens=1,2,3* delims= " %%i IN (%RESFILE%) DO (
      if ."%%i"==."%IPADDR%"  echo gefunden: " IP %%i hat MAC %%j"
      if ."%%i"==."%IPADDR%"  echo arp /s %%i %%j           >> %TMPBATCH%
      if ."%%j"==."%IPADDR%" set MYSERVER=1
    )
)

if ."%MYSERVER%"==."0" goto :eof

REM SERVERIP
nbtstat -a %IPADDR% |find /c "MAC Adresse"> %RESCOUNT%
FOR /F  %%i IN (%RESCOUNT%) DO set IPCOUNT=%%i
:: echo gefundene MACs: %IPCOUNT%
if NOT ."%IPCOUNT%"==."1" goto NOTFOUND
    nbtstat -a %IPADDR% |find "MAC Adresse" > %RESFILE%
    FOR /F "tokens=1,2,3* delims= " %%i IN (%RESFILE%) DO set MAC=%%l
    REM  MAC:%%i Adresse:%%j =:%%k MACADDR:%%l
    echo gefunden: " IP %IPADDR% hat MAC %MAC%"
    echo arp /s %IPADDR% %MAC%           >> %TMPBATCH%        
    goto :eof
:NOTFOUND
    color CF
    set MYERROR=1
    if ."%IPCOUNT%"==."0" (
        echo Keine MAC fr %IPADDR% gefunden
    ) ELSE (
        echo --------------------------------------------------------
        echo Kann keine eindeutige MAC zu %IPADDR% zuordnen
        echo Bitte Zuordnung IP-Adresse und MAC manuell eintragen
        echo in Datei: %CALLBAT%
        echo --------------------------------------------------------
    )

goto :eof
:: --------------------------------------------------------------------
:

:eof