' Shutdown.vbs, Version 1.00
' Shutdown Windows
' Check command line parameters
Select Case WScript.Arguments.Count
	Case 0
		' Default is local computer if none specified
		strComputer = "."
	Case 1
		Select Case WScript.Arguments(0)
			' "?", "-?" or "/?" invoke online help
			Case "?"
				Syntax
			Case "-?"
				Syntax
			Case "/?"
				Syntax
			Case Else
				strComputer = WScript.Arguments(0)
		End Select
	Case Else
		' More than 1 argument is not allowed
		Syntax
End Select

' Connect to computer
Set OpSysSet = GetObject("winmgmts:{(Shutdown)}//" & strComputer & "/root/cimv2").ExecQuery("select * from Win32_OperatingSystem where Primary=true")

' Actual shutdown
for each OpSys in OpSysSet
	OpSys.Shutdown()
next

' Done
WScript.Quit(0)


Sub Syntax
msg = vbCrLf & "Shutdown.vbs,  Version 1.00" & vbCrLf & _
      "Shutdown any WMI enabled computer on the network." & vbCrLf & _
      vbCrLf & "Usage:  CSCRIPT  SHUTDOWN.VBS  [ computer_name ]" & _
      vbCrLf & vbCrLf & _
      "Where:  " & Chr(34) & "computer_name" & Chr(34) & _
      " is the name of the computer to be shut down" & vbCrLf & _
      "        (without leading backslashes)." & vbCrLf & vbCrLf & _
      "        Default is " & Chr(34) & "." & Chr(34) & _
      " (the local computer)." & vbCrLf & vbCrLf & _
      "Note:   This script does NOT powerdown the computer." & _
      vbCrLf & vbCrLf & _
      "Written by Rob van der Woude" & vbCrLf & _
      "http://www.robvanderwoude.com" & vbCrLf & vbCrLf & _
      "Based on a post by Alex Angelopoulos on www.developersdex.com."
Wscript.Echo(msg)
Wscript.Quit(1)
End Sub

